package lab;

import javafx.animation.AnimationTimer;
import javafx.geometry.Point2D;
import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.paint.Color;

public class DrawingThread extends AnimationTimer {

	private final Canvas canvas;
	private final GraphicsContext gc;
	
	
	private Point2D p = new Point2D(0, 100);
	
	private Point2D v = new Point2D(50, 0);
	
	private long lastTimeOffset = -1;

	public DrawingThread(Canvas canvas) {
		this.canvas = canvas;
		this.gc = canvas.getGraphicsContext2D();
		
	}

	/**
	  * Draws objects into the canvas. Put you code here. 
	 */
	@Override
	public void handle(long now) {
		gc.setFill(Color.YELLOW);
		gc.clearRect(0, 0, canvas.getWidth(), canvas.getHeight());
		paintUFO(p.getX(), p.getY());
		if (lastTimeOffset >= 0) {
			//compute simulation
			double deltaT = (now - lastTimeOffset)/1e9;
			p = new Point2D(p.getX() + v.getX()*deltaT,p.getY() + v.getY()*deltaT);
		}
		
		lastTimeOffset = now;
	}
	
	
	void paintUFO(double x, double y) {
		// put your code here
		gc.setFill(Color.AQUA);
		//gc.setStroke(Color.BLACK);
		gc.fillOval(15 + x, 0 + y, 30, 20);
		gc.setFill(Color.SILVER);
		gc.fillRect(0 + x, 8 + y, 60, 5);
	}

}
